import connexion
import six

from swagger_server.models.department import Department  # noqa: E501
from swagger_server.models.department_crud import DepartmentCRUD  # noqa: E501
from swagger_server.models.departments import Departments  # noqa: E501

from . import check_error
import json

@check_error
def add_department(body):  # noqa: E501
    """Add a new department

    create new department # noqa: E501

    :param body: Department object that needs to be added
    :type body: dict | bytes

    :rtype: Department
    """
    if connexion.request.is_json:
        body = DepartmentCRUD.from_dict(connexion.request.get_json())  # noqa: E501
    return Departments().append(body)


@check_error
def delete_department(departmentId):  # noqa: E501
    """Deletes a department

    delete department by Id # noqa: E501

    :param departmentId: Department id to delete
    :type departmentId: int

    :rtype: None
    """
    department = Departments().getDepartmentById(departmentId)
    Departments().remove(department)
    return json.dumps({'status' : 'ok'}), 200


@check_error
def get_department(departmentId):  # noqa: E501
    """Find department by ID

    Returns a department # noqa: E501

    :param departmentId: ID of department that needs to be fetched
    :type departmentId: int

    :rtype: Department
    """
    return Departments().getDepartmentById(departmentId)


@check_error
def get_departments():  # noqa: E501
    """list of department

    Returns list of department # noqa: E501


    :rtype: List[Department]
    """
    return Departments()


@check_error
def update_department(departmentId, body):  # noqa: E501
    """Updates a department with form data

    update department by Id # noqa: E501

    :param departmentId: ID of department that needs to be updated
    :type departmentId: int
    :param body: Department object that needs to be updated
    :type body: dict | bytes

    :rtype: None
    """
    if connexion.request.is_json:
        body = Department.from_dict({**connexion.request.get_json(), "id":departmentId})
    return Departments().update(body)
