# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class ErrorModel(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, status: int=None, type: str=None, title: str=None, detail: str=None, instance: str=None):  # noqa: E501
        """ErrorModel - a model defined in Swagger

        :param status: The status of this ErrorModel.  # noqa: E501
        :type status: int
        :param type: The type of this ErrorModel.  # noqa: E501
        :type type: str
        :param title: The title of this ErrorModel.  # noqa: E501
        :type title: str
        :param detail: The detail of this ErrorModel.  # noqa: E501
        :type detail: str
        :param instance: The instance of this ErrorModel.  # noqa: E501
        :type instance: str
        """
        self.swagger_types = {
            'status': int,
            'type': str,
            'title': str,
            'detail': str,
            'instance': str
        }

        self.attribute_map = {
            'status': 'status',
            'type': 'type',
            'title': 'title',
            'detail': 'detail',
            'instance': 'instance'
        }

        self._status = status
        self._type = type
        self._title = title
        self._detail = detail
        self._instance = instance

    @classmethod
    def from_dict(cls, dikt) -> 'ErrorModel':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The errorModel of this ErrorModel.  # noqa: E501
        :rtype: ErrorModel
        """
        return util.deserialize_model(dikt, cls)

    @property
    def status(self) -> int:
        """Gets the status of this ErrorModel.


        :return: The status of this ErrorModel.
        :rtype: int
        """
        return self._status

    @status.setter
    def status(self, status: int):
        """Sets the status of this ErrorModel.


        :param status: The status of this ErrorModel.
        :type status: int
        """

        self._status = status

    @property
    def type(self) -> str:
        """Gets the type of this ErrorModel.


        :return: The type of this ErrorModel.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type: str):
        """Sets the type of this ErrorModel.


        :param type: The type of this ErrorModel.
        :type type: str
        """

        self._type = type

    @property
    def title(self) -> str:
        """Gets the title of this ErrorModel.


        :return: The title of this ErrorModel.
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title: str):
        """Sets the title of this ErrorModel.


        :param title: The title of this ErrorModel.
        :type title: str
        """

        self._title = title

    @property
    def detail(self) -> str:
        """Gets the detail of this ErrorModel.


        :return: The detail of this ErrorModel.
        :rtype: str
        """
        return self._detail

    @detail.setter
    def detail(self, detail: str):
        """Sets the detail of this ErrorModel.


        :param detail: The detail of this ErrorModel.
        :type detail: str
        """

        self._detail = detail

    @property
    def instance(self) -> str:
        """Gets the instance of this ErrorModel.


        :return: The instance of this ErrorModel.
        :rtype: str
        """
        return self._instance

    @instance.setter
    def instance(self, instance: str):
        """Sets the instance of this ErrorModel.


        :param instance: The instance of this ErrorModel.
        :type instance: str
        """

        self._instance = instance


# add by FAO
from connexion.problem import problem

class Error(Exception, ErrorModel):
    
    def __init__(self, status=400, title=None, type=None,
                      instance=None, headers=None, ext=None, key=None):
        Exception.__init__(self)
        ErrorModel.__init__(self, status, type, title, key, instance)
        self._key = key
        self.ext = ext
        self.headers = headers
    
    def __str__(self):
        return self._key

    def to_problem(self):
        return problem(status=self.status, title=self.title, detail=self.__str__(),
                      type=self.type, instance=self.instance, headers=self.headers,
                      ext=self.ext)
