import logging

import connexion
from flask_testing import LiveServerTestCase

from flask import Flask

from swagger_server.encoder import JSONEncoder
import sys


class BaseTestCase(LiveServerTestCase):

    def create_app(self):
        logging.getLogger('connexion.operation').setLevel('ERROR')
        app = connexion.App(__name__, specification_dir='../swagger/')
        app.app.json_encoder = JSONEncoder
        app.add_api('swagger.yaml')
        app.app.run = self.getRun()
        if sys.version_info[0] >= 3:
            import warnings
            warnings.simplefilter("ignore")
        return app.app

    def getRun(self):
        def run(host=None, port=None, debug=None,
                load_dotenv=True, **options):
            Flask.run(self.app, host='0.0.0.0', port=port, debug=debug,
                load_dotenv=load_dotenv, **options)
        return run