# coding: utf-8

from __future__ import absolute_import

from flask import json
from six import BytesIO
import urllib.request
from urllib.parse import urlparse
import socket

from swagger_server import encoder
from swagger_server.testfct import BaseTestCase

from flask import Flask
from flask_testing import LiveServerTestCase

from selenium import webdriver
from selenium.webdriver.common.desired_capabilities import DesiredCapabilities
from selenium.webdriver.common.keys import Keys
from selenium.webdriver.common.by import By
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.support import expected_conditions as EC

import connexion

class TestDepartmentAPI(BaseTestCase):

    def setUp(self):
        self.driver_firefox = webdriver.Remote(
                command_executor='http://seleniumf:4444/wd/hub',
                desired_capabilities=
                {
                    "browserName": "firefox",
                    "version": "",
                    "platform": "ANY",
                    "javascriptEnabled": True
                })
        self.driver_chrome = webdriver.Remote(
                command_executor='http://seleniumc:4444/wd/hub',
                desired_capabilities=
                {
                    "browserName": "chrome",
                    "version": "",
                    "platform": "ANY",
                    "javascriptEnabled": True
                })
        self._ip="localhost"
        data = urllib.request.urlopen("http://seleniumf:4444/wd/hub")
        addr = socket.gethostbyname(urlparse(data.geturl()).hostname).split('.')
        for p in socket.gethostbyname_ex(socket.gethostname())[2]:
            if p.split('.')[0:2] == addr[0:2]:
                self._ip = p
    
    def get_expose_url(self):
        return 'http://%s:%s/api/v1/ui' % (self._ip,self.get_server_url().split(":")[-1])

    def test_server_is_up_and_running(self):
        response = urllib.request.urlopen(self.get_expose_url())
        self.assertEqual(response.code, 200)

    def test_selenium_firefox_is_up(self):
        with self.driver_firefox as c:
            c.get(self.get_expose_url())
            self.assertIn("Swagger UI", c.title)

    def test_selenium_chrome_is_up(self):
        with self.driver_chrome as c:
            c.get(self.get_expose_url())
            self.assertIn("Swagger UI", c.title)


    def test_search_department(self):
        with self.driver_chrome as c:
            c.get(self.get_expose_url())
            print("/////////////////////////////////////////////////")
            print(c.page_source)
            print("/////////////////////////////////////////////////")
            c.find_elements_by_xpath("//a[@data-id='department']").clik()
            c.find_elements_by_xpath("//li[@id='department_get_departments']//a[@class='toggleOperation ']").clik()
            button = c.find_element_by_id("department_get_departments_content").find_element_by_class_name("submit")
            button.click()
            c.implicitly_wait(2)
            self.assertEqual(len(driver.find_element_by_xpath("//div[@id='department_get_departments_content']//*[@class='block response_code']/pre[text()='200']")), 1)