# coding: utf-8

from __future__ import absolute_import

from flask import json
from six import BytesIO

from swagger_server.models.department import Department  # noqa: E501
from swagger_server.models.department_crud import DepartmentCRUD  # noqa: E501
from swagger_server.models.error_model import ErrorModel  # noqa: E501
from swagger_server.testunit import BaseTestCase
from swagger_server.models.departments import Departments  # noqa: E501


class TestDepartmentController(BaseTestCase):
    """DepartmentController integration test stubs"""

    def test_add_department(self):
        """Test case for add_department

        Add a new department
        """
        body = DepartmentCRUD()
        body.lib = 'department'
        response = self.client.open(
            '/api/v1/department',
            method='POST',
            data=json.dumps(body),
            content_type='application/json')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))
    
    def create_department(self):
        try:
            dept = Departments().getDepartmentById(999)
        except:
            dept = Department(id=999,lib="test dept")
            Departments().append(dept)
        return dept 

    def test_delete_department(self):
        """Test case for delete_department

        Deletes a department
        """

        response = self.client.open(
            '/api/v1/department/{departmentId}'.format(departmentId=self.create_department().id),
            method='DELETE',
            content_type='application/json')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_get_department(self):
        """Test case for get_department

        Find department by ID
        """
        response = self.client.open(
            '/api/v1/department/{departmentId}'.format(departmentId=self.create_department().id),
            method='GET',
            content_type='application/json')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_get_departments(self):
        """Test case for get_departments

        list of department
        """
        response = self.client.open(
            '/api/v1/department',
            method='GET',
            content_type='application/json')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_update_department(self):
        """Test case for update_department

        Updates a department with form data
        """
        response = self.client.open(
            '/api/v1/department/{departmentId}'.format(departmentId=self.create_department().id),
            method='PUT',
            data=json.dumps({"lib":"test"}),
            content_type='application/json')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))


if __name__ == '__main__':
    import unittest
    unittest.main()
